Index: /palm/trunk/SOURCE/microphysics.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics.f90	(revision 1360)
+++ /palm/trunk/SOURCE/microphysics.f90	(revision 1361)
@@ -960,11 +1643,19 @@
 !
 !--          Slope parameter of gamma distribution (Seifert, 2008):
-             lambda_r = ( ( mu_r + 3.0_wp ) * ( mu_r + 2.0_wp ) *          &
-                        ( mu_r + 1.0_wp ) )**( 1.0_wp / 3.0_wp ) / dr
-
-             w_nr(k) = MAX( 0.1_wp, MIN( 20.0_wp, a_term - b_term * ( 1.0_wp +    &
-                       c_term / lambda_r )**( -1.0_wp * ( mu_r + 1.0_wp ) ) ) )
-             w_qr(k) = MAX( 0.1_wp, MIN( 20.0_wp, a_term - b_term * ( 1.0_wp +    &
-                       c_term / lambda_r )**( -1.0_wp * ( mu_r + 4.0_wp ) ) ) )
+             lambda_r = ( ( mu_r + 3.0_wp ) * ( mu_r + 2.0_wp ) *              &
+                          ( mu_r + 1.0_wp ) )**( 1.0_wp / 3.0_wp ) / dr
+
+             w_nr(k) = MAX( 0.1_wp, MIN( 20.0_wp,                              &
+                                         a_term - b_term * ( 1.0_wp +          &
+                                            c_term / lambda_r )**( -1.0_wp *   &
+                                            ( mu_r + 1.0_wp ) )                &
+                                        )                                      &
+                          )
+             w_qr(k) = MAX( 0.1_wp, MIN( 20.0_wp,                              &
+                                         a_term - b_term * ( 1.0_wp +          &
+                                            c_term / lambda_r )**( -1.0_wp *   &
+                                            ( mu_r + 4.0_wp ) )                &
+                                       )                                       &
+                          )
           ELSE
              w_nr(k) = 0.0_wp
@@ -981,7 +1672,7 @@
 !--    Compute Courant number
        DO  k = nzb_s_inner(j,i)+1, nzt
-          c_nr(k) = 0.25_wp * ( w_nr(k-1) + 2.0_wp * w_nr(k) + w_nr(k+1) ) * &
+          c_nr(k) = 0.25_wp * ( w_nr(k-1) + 2.0_wp * w_nr(k) + w_nr(k+1) ) *   &
                     dt_micro * ddzu(k)
-          c_qr(k) = 0.25_wp * ( w_qr(k-1) + 2.0_wp * w_qr(k) + w_qr(k+1) ) * &
+          c_qr(k) = 0.25_wp * ( w_qr(k-1) + 2.0_wp * w_qr(k) + w_qr(k+1) ) *   &
                     dt_micro * ddzu(k)
        ENDDO     
@@ -995,6 +1686,7 @@
              d_max  = MAX( qr_1d(k+1), qr_1d(k), qr_1d(k-1) ) - qr_1d(k)
 
-             qr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min, 2.0_wp * d_max, &
-                                                     ABS( d_mean ) )
+             qr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min,        &
+                                                        2.0_wp * d_max,        &
+                                                        ABS( d_mean ) )
 
              d_mean = 0.5_wp * ( nr_1d(k+1) + nr_1d(k-1) )
@@ -1002,6 +1694,7 @@
              d_max  = MAX( nr_1d(k+1), nr_1d(k), nr_1d(k-1) ) - nr_1d(k)
 
-             nr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min, 2.0_wp * d_max, &
-                                                     ABS( d_mean ) )
+             nr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min,        &
+                                                        2.0_wp * d_max,        &
+                                                        ABS( d_mean ) )
           ENDDO
 
@@ -1026,6 +1719,6 @@
           c_run = MIN( 1.0_wp, c_nr(k) )
           DO WHILE ( c_run > 0.0_wp  .AND.  k_run <= nzt )
-             flux  = flux + hyrho(k_run) *                                    &
-                     ( nr_1d(k_run) + nr_slope(k_run) * ( 1.0_wp - c_run ) *     &
+             flux  = flux + hyrho(k_run) *                                     &
+                     ( nr_1d(k_run) + nr_slope(k_run) * ( 1.0_wp - c_run ) *   &
                      0.5_wp ) * c_run * dzu(k_run)
              z_run = z_run + dzu(k_run)
@@ -1036,10 +1729,10 @@
 !--       It is not allowed to sediment more rain drop number density than 
 !--       available
-          flux = MIN( flux,                                                   &
+          flux = MIN( flux,                                                    &
                       hyrho(k) * dzu(k+1) * nr_1d(k) + sed_nr(k+1) * dt_micro )
 
           sed_nr(k) = flux / dt_micro
-          nr_1d(k)  = nr_1d(k) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /    &
-                                 hyrho(k) * dt_micro
+          nr_1d(k)  = nr_1d(k) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /     &
+                                    hyrho(k) * dt_micro
 !
 !--       Sum up all rain water content which contributes to the flux 
@@ -1050,8 +1743,8 @@
           c_run = MIN( 1.0_wp, c_qr(k) )
 
-          DO WHILE ( c_run > 0.0_wp  .AND.  k_run <= nzt-1 )
-
-             flux  = flux + hyrho(k_run) *                                    &
-                     ( qr_1d(k_run) + qr_slope(k_run) * ( 1.0_wp - c_run ) *    &
+          DO WHILE ( c_run > 0.0_wp  .AND.  k_run <= nzt )
+
+             flux  = flux + hyrho(k_run) *                                     &
+                     ( qr_1d(k_run) + qr_slope(k_run) * ( 1.0_wp - c_run ) *   &
                      0.5_wp ) * c_run * dzu(k_run)
              z_run = z_run + dzu(k_run)
@@ -1062,29 +1755,34 @@
 !
 !--       It is not allowed to sediment more rain water content than available
-          flux = MIN( flux,                                                   &
+          flux = MIN( flux,                                                    &
                       hyrho(k) * dzu(k) * qr_1d(k) + sed_qr(k+1) * dt_micro )
 
           sed_qr(k) = flux / dt_micro
 
-          qr_1d(k) = qr_1d(k) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+          qr_1d(k) = qr_1d(k) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
                                 hyrho(k) * dt_micro
-          q_1d(k)  = q_1d(k)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+          q_1d(k)  = q_1d(k)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
                                 hyrho(k) * dt_micro 
-          pt_1d(k) = pt_1d(k) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+          pt_1d(k) = pt_1d(k) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
                                 hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
 !
 !--       Compute the rain rate
-          prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) *                    &
-                       weight_substep(intermediate_timestep_count)
+          IF ( call_microphysics_at_all_substeps )  THEN
+             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) *                  &
+                          weight_substep(intermediate_timestep_count)
+          ELSE
+             prr(k,j,i) = sed_qr(k) / hyrho(k)
+          ENDIF
+
        ENDDO
 
 !
 !--    Precipitation amount
-       IF ( intermediate_timestep_count == intermediate_timestep_count_max    &
-            .AND.  ( dt_do2d_xy - time_do2d_xy ) <                            &
-            precipitation_amount_interval )  THEN
-
-          precipitation_amount(j,i) = precipitation_amount(j,i) +   &
-                                      prr(nzb_s_inner(j,i)+1,j,i) *      &
+       IF ( intermediate_timestep_count == intermediate_timestep_count_max     &
+            .AND.  ( dt_do2d_xy - time_do2d_xy ) <                             &
+                   precipitation_amount_interval )  THEN
+
+          precipitation_amount(j,i) = precipitation_amount(j,i) +              &
+                                      prr(nzb_s_inner(j,i)+1,j,i) *            &
                                       hyrho(nzb_s_inner(j,i)+1) * dt_3d
        ENDIF
@@ -1092,5 +1790,7 @@
     END SUBROUTINE sedimentation_rain_ij
 
-
+!------------------------------------------------------------------------------!
+! Call for all optimizations
+!------------------------------------------------------------------------------!
 !
 !-- This function computes the gamma function (Press et al., 1992). 
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1360)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1361)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! tend_* removed
+! call_microphysics_at_all_substeps added
+! default of drizzle set to true
 ! 
 ! Former revisions:
@@ -287,7 +289,7 @@
           diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt, flux_l_q,        &
           flux_l_qr, flux_l_sa, flux_l_u, flux_l_v, flux_l_w, kh, km, lad_s,   &
-          lad_u, lad_v, lad_w, lai, l_wall, p_loc, sec, sls, tend, tend_pt,    &
-          tend_nr, tend_q, tend_qr, tric, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l,   &
-          v_m_n, v_m_r, v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
+          lad_u, lad_v, lad_w, lai, l_wall, p_loc, sec, sls, tend, tric,       &
+          u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l,       &
+          w_m_n, w_m_r, w_m_s
 
 #if defined( __nopointer )
@@ -368,5 +370,5 @@
                  b_vent = 0.308_wp,    & !: coef. for ventilation effect
                  beta_cc = 3.09E-4_wp, & !: coef. in turb. parametrization (cm-2 s3)
-                 bfactor,           &
+                 bfactor,              & !: solution effect on diffusional growth
                  c_1 = 4.82E-6_wp,     & !: coef. in turb. parametrization (m)
                  c_2 = 4.8E-6_wp,      & !: coef. in turb. parametrization (m)
@@ -384,5 +386,5 @@
                 cp = 1005.0_wp,       & !: heat capacity of dry air (J kg-1 K-1) 
                 diff_coeff_l = 0.23E-4_wp, & !: diffusivity of water vapor (m2 s-1)
-                effective_coll_efficiency, & !:
+                effective_coll_efficiency, & !: effective collision efficiency
                 eps_ros = 1.0E-4_wp,  & !: accuracy of Rosenbrock method
                 eps_sb = 1.0E-20_wp,  & !: threshold in two-moments scheme
@@ -408,4 +410,5 @@
                 schmidt = 0.71_wp,    & !: Schmidt number
                 schmidt_p_1d3,        & !: schmidt**( 1.0 / 3.0 )
+                sed_qc_const,         & !: const. for sedimentation of cloud water
                 sigma_gc = 1.3_wp,    & !: log-normal geometric standard deviation
                 stp = 2.5066282746310005_wp, & !: parameter in gamma function
@@ -592,4 +595,5 @@
                 bc_lr_raddir = .FALSE., bc_ns_cyc = .TRUE., &
                 bc_ns_dirrad = .FALSE., bc_ns_raddir = .FALSE.,&
+                call_microphysics_at_all_substeps = .FALSE., &
                 call_psolver_at_all_substeps = .TRUE., &
                 cloud_droplets = .FALSE., cloud_physics = .FALSE., &
@@ -604,5 +608,5 @@
                 do_sum = .FALSE., &
                 dp_external = .FALSE., dp_smooth = .FALSE., &
-                drizzle = .FALSE., dt_fixed = .FALSE., &
+                drizzle = .TRUE., dt_fixed = .FALSE., &
                 dt_3d_reached, dt_3d_reached_l, exchange_mg = .FALSE., &
                 first_call_lpm = .TRUE., &
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1360)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1361)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +call_microphysics_at_all_substeps
 ! 
 ! Former revisions:
@@ -148,5 +148,6 @@
                bottom_salinityflux, building_height, building_length_x,        &
                building_length_y, building_wall_left, building_wall_south,     &
-               call_psolver_at_all_substeps, canopy_mode, canyon_height,       &
+               call_microphysics_at_all_substeps, call_psolver_at_all_substeps,&
+               canopy_mode, canyon_height,                                     &
                canyon_width_x, canyon_width_y, canyon_wall_left,               &
                canyon_wall_south, cfl_factor,                                  &
@@ -248,5 +249,6 @@
              bottom_salinityflux, building_height, building_length_x, &
              building_length_y, building_wall_left, building_wall_south, &
-             call_psolver_at_all_substeps, canopy_mode, canyon_height, &
+             call_psolver_at_all_substeps, call_microphysics_at_all_substeps, &
+             canopy_mode, canyon_height, &
              canyon_width_x, canyon_width_y, canyon_wall_left, &
              canyon_wall_south, c_sedimentation, cfl_factor, cloud_droplets, &
Index: /palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1360)
+++ /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1361)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfix: calculation of turbulent fluxes of rain water content (qrsws) and rain 
+! drop concentration (nrsws) added
 ! 
 ! Former revisions:
@@ -64,12 +65,13 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, pt, q, qs, qsws, rif, shf, ts, u, us, usws, v, vpt, vsws,    &
-               zu, zw, z0, z0h
+        ONLY:  e, nr, nrs, nrsws, pt, q, qr, qrs, qrsws, qs, qsws, rif, shf,   &
+               ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h
 
     USE control_parameters,                                                    &
-        ONLY:  constant_heatflux, constant_waterflux, coupling_mode, g,        &
-               humidity, ibc_e_b, kappa, large_scale_forcing, lsf_surf,        &
-               passive_scalar, pt_surface, q_surface, rif_max, rif_min,        &
-               run_coupled, surface_pressure
+        ONLY:  cloud_physics, constant_heatflux, constant_waterflux,           &
+               coupling_mode, g, humidity, ibc_e_b, icloud_scheme, kappa,      &
+               large_scale_forcing, lsf_surf, passive_scalar, precipitation,   &
+               pt_surface, q_surface, rif_max, rif_min, run_coupled,           &
+               surface_pressure
 
     USE indices,                                                               &
@@ -96,6 +98,7 @@
 !
 !-- Data information for accelerators
-    !$acc data present( e, nzb_u_inner, nzb_v_inner, nzb_s_inner, pt, q, qs ) &
-    !$acc      present( qsws, rif, shf, ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h )
+    !$acc data present( e, nrsws, nzb_u_inner, nzb_v_inner, nzb_s_inner, pt )  &
+    !$acc      present( q, qs, qsws, qrsws, rif, shf, ts, u, us, usws, v )     &
+    !$acc      present( vpt, vsws, zu, zw, z0, z0h )
 ! 
 !-- Compute theta*
@@ -383,4 +386,47 @@
           ENDDO
        ENDIF
+
+       IF ( cloud_physics  .AND.  icloud_scheme == 0  &
+            .AND.  precipitation )  THEN
+
+          !$OMP PARALLEL DO PRIVATE( a, b, k, z_p )
+          !$acc kernels loop independent
+          DO  i = nxlg, nxrg
+             !$acc loop independent
+             DO  j = nysg, nyng
+
+                k   = nzb_s_inner(j,i)
+                z_p = zu(k+1) - zw(k)
+
+                IF ( rif(j,i) >= 0.0 )  THEN
+!
+!--                Stable stratification
+                   qrs(j,i) = kappa * ( qr(k+1,j,i) - qr(k,j,i) ) / (          &
+                                  LOG( z_p / z0h(j,i) ) +                      &
+                                  5.0 * rif(j,i) * ( z_p - z0h(j,i) ) / z_p )
+                   nrs(j,i) = kappa * ( nr(k+1,j,i) - nr(k,j,i) ) / (          &
+                                  LOG( z_p / z0h(j,i) ) +                      &
+                                  5.0 * rif(j,i) * ( z_p - z0h(j,i) ) / z_p )
+
+                ELSE
+!
+!--                Unstable stratification
+                   a = SQRT( 1.0 - 16.0 * rif(j,i) ) 
+                   b = SQRT( 1.0 - 16.0 * rif(j,i) * z0h(j,i) / z_p ) 
+ 
+                   qrs(j,i) = kappa * ( qr(k+1,j,i) - qr(k,j,i) ) /   (        &
+                             LOG( z_p / z0h(j,i) ) -                           &
+                             2.0 * LOG( (1.0 + a ) / ( 1.0 + b ) ) )
+                   nrs(j,i) = kappa * ( nr(k+1,j,i) - nr(k,j,i) ) /   (        &
+                             LOG( z_p / z0h(j,i) ) -                           &
+                             2.0 * LOG( (1.0 + a ) / ( 1.0 + b ) ) )
+
+                ENDIF
+
+             ENDDO
+          ENDDO
+
+       ENDIF
+
     ENDIF
 
@@ -396,4 +442,11 @@
        CALL exchange_horiz_2d( qsws )
        !$acc update device( qsws )
+       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+            precipitation )  THEN
+          !$acc update host( qrsws, nrsws )
+          CALL exchange_horiz_2d( qrsws )
+          CALL exchange_horiz_2d( nrsws )
+          !$acc update device( qrsws, nrsws )
+       ENDIF
     ENDIF
 
@@ -425,4 +478,18 @@
 
 !
+!-- Compute (turbulent) fluxes of rain water content and rain drop concentartion
+    IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
+       !$OMP PARALLEL DO
+       !$acc kernels loop independent
+       DO  i = nxlg, nxrg
+          !$acc loop independent
+          DO  j = nysg, nyng
+             qrsws(j,i) = -qrs(j,i) * us(j,i)
+             nrsws(j,i) = -nrs(j,i) * us(j,i)
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
 !-- Bottom boundary condition for the TKE
     IF ( ibc_e_b == 2 )  THEN
